; GUI #
;Light
include win64a.inc
; --------------- 
WINDOWWIDTH  = 400
WINDOWHEIGHT = 440

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 or \
	(sizeof WNDCLASSEX)	;cbSize & style
	push	rax
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset pfd
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset pfd
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax

	invoke  glShadeModel,GL_SMOOTH

	mov	r8d,offset mat_specular
	invoke  glMaterialfv,GL_FRONT,GL_SPECULAR
	mov	r8d,offset mat_shininess
	invoke  glMaterialfv,GL_FRONT,GL_SHININESS
	mov	r8d,offset light_position
	invoke  glLightfv,GL_LIGHT0,GL_POSITION

	invoke  glEnable,GL_LIGHTING
	invoke  glEnable,GL_LIGHT0
	invoke  glEnable,GL_DEPTH_TEST

	invoke	GLReshape,WINDOWWIDTH, WINDOWHEIGHT
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	movzx	ecx,r9w
	mov	edx,r9d
	shr	edx,16
	invoke	GLReshape
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke	BeginPaint
; --------------- Display the scene
	invoke  glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
	movq	xmm0,constd1
	invoke  glutSolidSphere,,20,16
	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
	lea	edx,ps
	invoke	EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
GLReshape proc w:dword,h:dword
local	result:QWORD

	mov	w,ecx
	mov	h,edx
	fninit
	mov	r8d,ecx
	mov	r9d,edx
	invoke  glViewport,0,0
	invoke  glMatrixMode, GL_PROJECTION
	invoke  glLoadIdentity
	fld	const_1_5
	mov     eax,h
	cmp	w,eax
	ja	@f
	fimul   h
	fidiv   w
	fstp    result
	movq	xmm2,result
	fld	const1_5
	fimul   h
	fidiv   w
	fstp    result
	movq	xmm3,result
	movq	xmm1,constd1_5
	movq	xmm0,constd_1_5
	jmp	@0
@@:	fimul	w
	fidiv	h
	fstp	result
	movq	xmm0,result
	fld	const1_5
	fimul   w
	fidiv   h
	fstp    result
	movq	xmm1,result
	movq	xmm3,constd1_5
	movq	xmm2,constd_1_5
@0:	invoke  glOrtho,,,,,constd_10,constd10

	invoke  glMatrixMode,GL_MODELVIEW
	invoke  glLoadIdentity
	leave
	retn
GLReshape	endp
;.data--------------------------------------------
hDC	dq	?
hrc	dq	?

pfd	label	PIXELFORMATDESCRIPTOR 
;   
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1;  
;  ,     
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW 
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	16;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	0;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  

constd1		dq 1.0
const_1_5	dd -1.5
const1_5	dd 1.5
constd_1_5	dq -1.5
constd1_5	dq 1.5
constd_10	dq -10.0
constd10	dq 10.0

mat_specular	dd 1.0, 1.0, 1.0, 1.0
mat_shininess	dd 50.0
light_position	dd 1.0, 1.0, 1.0, 0.0
szClassName	db "Uncle Remus tales:#40 OpenGL - Light",0
FileName	db "br_Rabbit3.cur",0
end